﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private PrintCLV As CustomListView
	Private NameLbl As B4XView
	Private EmailLbl As B4XView
	Private Phone1Lbl As B4XView
	Private di As DocumentInteraction
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Sub Button1_Click
	'xui.MsgboxAsync("Hello world!", "B4X")
	
	
Try	
	Dim D As String
	Dim LPCTP As Int = 35  'Lines Per Col this Page
	Dim TotalRows As Int = 15  'Total Number of Rows to print
	Dim ColHight As Int = 792  'col height - depends on title/address pageheight - 10 top and 10 bottom margins
	Dim FPColTop As Int = 40  'col TOP - depends on title/address - ALSO the LOCATION of title/Address
	Dim LineHeight As Double = ColHight / 40  'THIS DOES NOT CHANGE HEIGHT OF EACH CLOUMN - it is used to calculate the HEIGHT of the rect we are putting the BMP in
	Dim pdf As PDFDocument, M As Map, X As Int, Y As Int, DestRect As Rect, PageUnfinished As Boolean = False  'ignore
	D = File.DirDocuments
	If File.Exists(D, "Test.pdf") Then
		File.Delete(D, "Test.pdf")
	End If
	Dim PDFCanvas As Canvas
	pdf.Initialize(D, "Test.pdf")
	PDFCanvas.InitializePDF(D, "Test.pdf", 612, 792)
	PageUnfinished = True
	LPCTP = Min(LPCTP, Ceil(((TotalRows / 2)))) + 1  ' this gives us the number of rows/col this page + 1 for the header
	Dim P As B4XView = xui.CreatePanel("")
	PrintCLV.Add(P, "")
	'UNREM next line and it works - note the two lines above this one are only needed to keep the next line from failing
	'Dim bmp As B4XBitmap = PrintCLV.sv.ScrollViewInnerPanel.Snapshot  'This seems to be required to fix a bug in B4i
	PrintCLV.Clear
	Dim YYY As Int
	For YYY = 1 To 15
		Dim P As B4XView = xui.CreatePanel("")
		P.LoadLayout("PrintItem")
		P.SetLayoutAnimated(0, 0, 0, PrintCLV.AsView.Width, NameLbl.Height)
		PrintCLV.Add(P, "")
		NameLbl.Text = $"Name ${YYY}"$
		Phone1Lbl.Text = $"Phone ${YYY}"$
		EmailLbl.Text = $"EMail  ${YYY}"$
		X = X + 1
	Next
	Dim bmp As B4XBitmap = PrintCLV.sv.ScrollViewInnerPanel.Snapshot
	DestRect.Initialize(40, FPColTop, 305, (LineHeight * PrintCLV.Size) + FPColTop - 10)  '(612W, 792H) 297
	PDFCanvas.DrawBitmap(bmp, DestRect)
	PDFCanvas.Release
	pdf.Release
	If File.Exists(File.DirDocuments, "Test.pdf") Then
		di.Initialize("di", File.DirDocuments, "Test.pdf") '<--- open a file from the assets folder
		di.OpenFile(Root)
	End If
Catch
	Log("PrintBtn_Click: " & LastException)
End Try
	
End Sub


